unit DrawElements_f;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus,OpenGL;

const Velikost = 256;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }

    RC : HGLRC;
    buffer : array[1..Velikost,1..Velikost] of record
                                             blue : byte;
                                             green : byte;
                                             red : byte
                                           end;
    procedure InitElements;                                       
    procedure DrawElements;
    procedure InicializaceOpenGL;
    procedure ZobrazitScenu;
    procedure PixelovyFormat(DC : HDC);
    procedure NastaveniProstoru;
    procedure VlastnostiObjektu;
    procedure LoadBitmap(Path : string);
    procedure VymazatPlochu(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure Svetlo1;

  public
    { Public declarations }
    X,Y,Z: real;
    UhelX,UhelY,UhelZ: integer;
  end;

//body
type TVertexPointer = array [0..100] of record
  X: TGLFloat;
  Y: TGLFloat;
  Z: TGLFloat;
end;

//texturova koordinace
type TCoordPointer = array [0..100] of record
  S: TGLFloat;
  K: TGLFloat;
end;

//indikator poli
type TIndices = array [0..100] of TGluInt;

var
  Form1: TForm1;
  Handles : integer;
  ThreadID : LongWord;

  VertexPointer: TVertexPointer;
  CoordPointer: TCoordPointer;
  Indices: TIndices;


implementation

{$R *.DFM}



const PFDError = 'Chyba pi nastaven PFD.';

function Tread(P : pointer) : integer;
var
  i: integer;
begin
  i := 1;
  repeat
    Form1.Repaint;
  until
    i = 2;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  FillChar(Handles, sizeof(Handles), 0);
end;

procedure TForm1.InitElements;
var
  Cesta : string;
begin
  Cesta := ExtractFilePath(Application.ExeName);
  LoadBitmap(Cesta + 'Image1.bmp');
  glBindTexture(GL_TEXTURE_2D, 0);
  glTexImage2d(GL_Texture_2D,0,3,Velikost,Velikost,0,GL_RGB,GL_Unsigned_byte,@buffer);


    //pozice bodu 1
    VertexPointer[0].X := -1;
    VertexPointer[0].Y := 1;
    VertexPointer[0].Z := 0;
    //texturova koordinace bodu 1
    CoordPointer[0].S := 1;
    CoordPointer[0].K := 1;
    //identifikace bodu 1
    Indices[0] := 0;

    //pozice bodu 2
    VertexPointer[1].X := 1;
    VertexPointer[1].Y := 1;
    VertexPointer[1].Z := 0;
    //texturova koordinace bodu 2
    CoordPointer[1].S := 0;
    CoordPointer[1].K := 1;
    //identifikace bodu 2
    Indices[1] := 1;

    //pozice bodu 3
    VertexPointer[2].X := -1;
    VertexPointer[2].Y := -1;
    VertexPointer[2].Z := 0;
    //texturova koordinace bodu 3
    CoordPointer[2].S := 1;
    CoordPointer[2].K := 0;
    //identifikace bodu 3
    Indices[2] := 2;


    //druhy trojuhelnik
    VertexPointer[3].X := -1;
    VertexPointer[3].Y := -1;
    VertexPointer[3].Z := 0;
    CoordPointer[3].S := 1;
    CoordPointer[3].K := 0;
    Indices[3] := 3;


    VertexPointer[4].X := 1;
    VertexPointer[4].Y := 1;
    VertexPointer[4].Z := 0;
    CoordPointer[4].S := 0;
    CoordPointer[4].K := 1;
    Indices[4] := 4;


    VertexPointer[5].X := 1;
    VertexPointer[5].Y := -1;
    VertexPointer[5].Z := 0;
    CoordPointer[5].S := 0;
    CoordPointer[5].K := 0;
    Indices[5] := 5;


    glEnableClientState(GL_COLOR_ARRAY);                               //aktivuje pole barev
    glEnableClientState(GL_VERTEX_ARRAY);                              //aktivuje pole bodu
    glEnableClientState(GL_TEXTURE_COORD_ARRAY);                       //aktivuje pole texturovych koordinaci

    glColorPointer( 4, GL_UNSIGNED_BYTE, 0, @Buffer );                 //nacte pole barev
    glTexCoordPointer(2, GL_FLOAT, 0, @CoordPointer);                  //nacte pole texturovych koordinaci
    glVertexPointer(3, GL_FLOAT, 0, @VertexPointer);                   //nacte pole bodu


end;

procedure TForm1.DrawElements;
begin
  glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_INT, @Indices);        //zobrazi vysledny objekt
end;

procedure TForm1.InicializaceOpenGL;
begin
  PixelovyFormat(Canvas.Handle);
  RC := wglCreateContext(Canvas.Handle);
  wglMakeCurrent(Canvas.Handle,RC);
  glClearColor(0.0,0.0,0.0,0.0);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_Texture_2D);
  glPixelStorei(GL_Unpack_Alignment,2);
  glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_S,GL_Repeat);
  glTexParameterf(GL_Texture_2D,GL_Texture_Wrap_T,GL_Repeat);
  glTexParameterf(GL_Texture_2D,GL_Texture_Mag_Filter,GL_Linear);
  glTexParameterf(GL_Texture_2D,GL_Texture_Min_Filter,GL_Linear);
  glTexEnvf(GL_Texture_Env, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  Svetlo1;
  InitElements;
  NastaveniProstoru;
  wglMakeCurrent(0,0);
end;

procedure TForm1.PixelovyFormat(DC : HDC);
var PFD : TPixelFormatDescriptor;
    nPixelFormat : integer;
begin
  FillChar(PFD,SizeOf(PFD),0);
  with PFD do
    begin
       nSize := SizeOf(TPixelFormatDescriptor);
       nVersion := 1;
       dwFlags := PFD_DRAW_TO_WINDOW or
                  PFD_SUPPORT_OPENGL or
                  PFD_DOUBLEBUFFER;
       iPixelType := PFD_TYPE_RGBA;
       cColorBits := 24;
       cDepthBits   := 32;
       iLayerType   := PFD_MAIN_PLANE;
    end;
  nPixelFormat := ChoosePixelFormat(DC,@PFD);
  Assert(nPixelFormat <> 0,PFDError);
  SetPixelFormat(DC,nPixelFormat,@PFD)
end;

procedure TForm1.NastaveniProstoru;
begin
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(30.0,ClientWidth / ClientHeight,1.0,100.0);
  glViewport(0,0,ClientWidth,ClientHeight);
end;
            
procedure TForm1.VlastnostiObjektu;
begin
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glTranslatef(X,Y,Z);				//pozice kamery
  glRotatef(UhelX, 1, 0, 0);			//rotace  X
  glRotatef(UhelY, 0, 1, 0);			//rotace  Y
  glRotatef(UhelZ, 0, 0, 1);			//rotace  Z }
  glTranslatef(X,Y,Z);				//pozice kamery


end;


procedure TForm1.LoadBitmap(Path : string);
//  nate bitmapu o velikosti 256 x 256 pixelu ze souboru
//  prohodi ervenou a modrou sloku
//  bitmapu jin velikosti je nutno upravit tak, aby
//  jeji ka a vka byla mocninou dvou
var
 X : TImage;
 bih : TBitmapInfoHeader;
 bi : TBitmapInfo;
 b : byte;
 i,j : word;
begin
  X := TImage.Create(Self);
  X.Picture.LoadFromFile(Path);
  with bih do
    begin
      biSize := SizeOf(bih);
      biWidth := Velikost;
      biHeight := Velikost;
      biPlanes := 1;
      biBitCount := 24;
      biCompression := BI_RGB;
      biSizeImage := Velikost;
      biXPelsPerMeter := 0;
      biYPelsPerMeter := 0;
      biClrImportant := 0;
      biClrUsed := 0;
    end;
  bi.bmiHeader := bih;
  GetDIBits(X.Picture.Bitmap.Canvas.Handle,X.Picture.Bitmap.Handle,
            0,Velikost,@buffer,bi,dib_rgb_colors);
  for i := 1 to Velikost do
    for j := 1 to Velikost do
      begin
        b := buffer[i,j].red;
        buffer[i,j].red := buffer[i,j].blue;
        buffer[i,j].blue := b;
      end;
  X.Free
end;

procedure TForm1.ZobrazitScenu;
begin
  wglMakeCurrent(Canvas.Handle,RC);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  VlastnostiObjektu;
  DrawElements;
  glFlush;
  SwapBuffers(Canvas.Handle);
  wglMakeCurrent(0,0)
end;

procedure TForm1.VymazatPlochu(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UhelX := 0;
  UhelY := 0;
  UhelZ := 0;
  X := 0; Y := 0; Z := -5.0;
  InicializaceOpenGL;
  Handles := BeginThread(nil, 0, Tread, nil, 0, ThreadID);
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  wglDeleteContext(RC);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
    ZobrazitScenu;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  wglMakeCurrent(Canvas.Handle,RC);
  NastaveniProstoru;
  ZobrazitScenu;
  wglMakeCurrent(0,0);
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_UP: begin  //ipka nahoru
        Z := Z + ((-sin((UhelY - 90) * (Pi/180))) * 0.2);
        X := X - ((sin((UhelY) * (Pi/180))) * 0.2);
    end;
  end;
  case Key of
    VK_DOWN: begin //ipka dolu
      Z := Z - ((-sin((UhelY - 90) * (Pi/180))) * 0.2);
      X := X + ((sin((UhelY) * (Pi/180))) * 0.2);
    end;
  end;
  case Key of
    VK_RIGHT: begin //doprava
      UhelY := UhelY + 3;
    end;
  end;
  case Key of
    VK_LEFT: begin //doleva
      UhelY := UhelY - 3;
    end;
  end;
  case Key of
    $51: begin //Q - Quit
      Application.Terminate;
    end;
  end;
end;

procedure TForm1.Svetlo1;
const
  glfLightAmbient : Array[0..3] of TGLfloat = (0.1, 0.1, 0.1, 1.0);  //GL_AMBIENT = ambientn svtlo, svtlo kter z i kdy jsou svtla vypnuta
  glfLightDiffuse : Array[0..3] of TGLfloat = (1.0, 1.0, 1.0, 1.0);  //GL_DIFFUSE = barva svtla, kter zdroj vyzauje do okol
  glfLightSpecular: Array[0..3] of TGLfloat = (0.5, 0.5, 0.5, 1.0);  //GL_SPECULAR = zrcadlov odraz svtla
  glfLightShininess: TGLFloat = 127;                                 //GL_SHININESS = intenzita svtelnho odlesku
  glflightPosition: Array[0..3] of TGLfloat = (-1.0,-1.0,1.0,1.0);   //GL_Position = pozice svtelnho bodu v prostoru
  glfSpotDirection: Array[0..3] of TGLfloat = (1.0,1.0,-1.0,1.0);    // GL_SPOT_DIRECTION = zadn smru svtelnho kuele
  glfLightEmission: Array[0..3] of TGLfloat = (0.0,0.0,0.0,1.0);     // svtlo, kter vyzauje urit objekt, nepsob jako zdroj svtla
  glfLinearAttenuation: TGLFloat = 0;                                // GL_LINEAR_ATTENUATION = linern slbnut intenzity svtla
  glfSpotExponent: TGLFloat = 1;                                     //GL_SPOT_EXPONENT = charakterizuje zpsob rozptylu svtla pi odrazu
  glfSpotCutoff:TGLFloat = 180;                                       //GL_SPOT_CUTOFF = hel, nm se kuel svtla rozevr od sv osy



begin
  glEnable(GL_DEPTH_TEST);

  glLightfv(GL_LIGHT1, GL_AMBIENT, @glfLightAmbient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @glfLightDiffuse);
  glLightfv(GL_LIGHT1, GL_SPECULAR, @glfLightSpecular);
  glLightfv(GL_LIGHT1, GL_SHININESS, @glfLightShininess);
  glLightfv(GL_LIGHT1, GL_POSITION,@glfLightPosition);
  glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, @glfSpotDirection);
  glLightfv(GL_LIGHT1, GL_EMISSION, @glfLightEmission);
  glLightfv(GL_LIGHT1, GL_LINEAR_ATTENUATION, @glfLinearAttenuation);
  glLightfv(GL_LIGHT1, GL_SPOT_EXPONENT, @glfSpotExponent);
  glLightfv(GL_LIGHT1, GL_SPOT_CUTOFF, @glfSpotCutoff);




  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT1);  // prvn svtlo

end;



end.
